// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"


// CSVNAdmin

class ATL_NO_VTABLE CSVNAdmin : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNAdmin, &CLSID_SVNAdmin>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNAdmin, &IID_ISVNAdmin, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNAdmin()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNADMIN)

BEGIN_COM_MAP(CSVNAdmin)
	COM_INTERFACE_ENTRY(ISVNAdmin)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(CreateRepository)(BSTR sReposPath, BSTR nReposType);
};

OBJECT_ENTRY_AUTO(__uuidof(SVNAdmin), CSVNAdmin)

